<?php

namespace FiloBlu\Flow\Model\Actions\From;

class Setdefaultforlocale {

    CONST ENTITY_TYPE_CODE = 'catalog_product';

    protected $_helper_product;
    protected $_product_factory;
    /**
    * @var Monolog\Logger
    */
    protected $_logger;

    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \FiloBlu\Flow\Helper\Data $helper_data,
        \FiloBlu\Flow\Helper\LoggerProvider $loggerProvider,
        \Magento\Catalog\Model\Product $productFactory,
        array $data = []
    ) {
        $this->_helper_data = $helper_data;
        $this->_product_factory = $productFactory;
        $this->_logger = $loggerProvider->getLogger();
    }

    public function process($attribute, $value, $storeId) {
       
        if (empty($value)) {
            return true;
        }
        
        $this->_logger->info(__METHOD__);
        
        // separatore |||
        $explode = array();
        $explode = explode( '|||', $value);
        
        $_attribute_value = $explode[0];
        $_stores = array();
        $_stores = explode( ';', $explode[1]);
        $_sku = $explode[2];
        $this->_logger->info('EXPLODE');
        $this->_logger->info(print_r($explode, true));
        
               

        
        $_store_ids = $this->_helper_data->getAllStoreIds();
        
        $product_id = $this->_product_factory->create()->getIdBySku($_sku);
        $product = $this->_product_factory->create()->setStoreId(0)->load($product_id);
        
        $product->setData($attribute->getAttributeCode(), $_attribute_value);
      
        $product->save();
        $this->_logger->info(print_r($_store_ids, true));
         
        if(is_array($_stores) && count($_stores)>=1) {

            foreach($_stores as $store) {

               $_store_id = $_store_ids[$store];
               // set "use default" for attribute in store view
               // $this->_logger->info('store ID: '.$_store_id . ' - '.$attribute->getAttributeCode() . ' ID: ' .$product->getId());  
               
               $product = $this->_product_factory->create()->setStoreId($_store_id)->load($product_id);
               
               $product->setData($attribute->getAttributeCode(), '');
               $product->setData($attribute->getAttributeCode(), false);
               
               
               $this->_logger->info('SAVED! '.$product->setStoreId($_store_id)->getData($attribute->getAttributeCode()) . ' ID: ' .$product->getId());   
               $product->save();
            }

        }
        
       

    }

}
